(defun c:carton()
(set)
(command "erase" "all" "")
(command "zoom" "all")
(reset)
(setq count 1)

(setq carton_id (load_dialog "carton.dcl"))
(if (not (new_dialog "carton" carton_id)) (exit))

(repeat 6
(start_image (setq img (strcat "c" (rtos count 2 0))))
(setq xx (dimx_tile img))
(setq yy (dimy_tile img))
(fill_image 0 0 xx yy -15)
(slide_image 0 0 xx yy (setq sld (strcat "sld" (rtos count 2 0))))
(end_image) 
(setq count (1+ count))
)

(action_tile "c1" "(done_dialog 1)")
(action_tile "c2" "(done_dialog 2)")
(action_tile "c3" "(done_dialog 3)")
(action_tile "c4" "(done_dialog 4)")
(action_tile "c5" "(done_dialog 5)")
(action_tile "c6" "(done_dialog 6)")

(action_tile "close" "(done_dialog 0)")

(setq what_next (start_dialog))
(unload_dialog carton_id)

(cond
 ((= what_next 1) (c1))
;((= what_next 2) (c2))
;((= what_next 3) (c3))
;((= what_next 4) (c4))
;((= what_next 5) (c5))
;((= what_next 6) (c6))
)
(princ)
) ;; defun c:carton

;*************;*************;*************;*************;*************;

(defun c1()

(setq c1_id (load_dialog "carton.dcl"))
(if (not (new_dialog "c1" c1_id)) (exit))

(start_image "c11")
(setq xx (dimx_tile "c11"))
(setq yy (dimy_tile "c11"))
(fill_image 0 0 xx yy -15)
(slide_image 0 0 xx yy "sld1")
(end_image) 

(if (not al_index) (setq al_index 0))
(setq al_list nil al_list '())
(setq file (open "c1list.txt" "r"))
(setq line (read-line file))
(while line
     (setq al_list (append al_list (list line)))
     (setq line (read-line file))
) ;; while
(close file)

(defun kb_switch()  ;;  KeyBoard ON
   (setq kb_list 1)
   (mode_tile "al_list" 1)
   (mode_tile "LS" 0)
   (mode_tile "WS" 0)
)

;;  End of the kb_switch function.

;;  Set up the list_switch function.

(defun list_switch()   ;; List ON
   (setq kb_list 0)
   (mode_tile "al_list" 0)
   (mode_tile "LS" 1)
   (mode_tile "WS" 1)
)
;;  End of the list_switch function.

(start_list "al_list")
(mapcar 'add_list al_list)
(end_list)
(action_tile "al_list" "(setq al_index (atoi $value))")

(if (not kb_list) (setq kb_list 1))
(if (not LS) (setq LS 550))
(if (not WS) (setq WS 350))
(if (not ls_inch) (setq ls_inch (/ ls 25.4)))
(if (not ws_inch) (setq ws_inch (/ ws 25.4)))
(if (not LL) (setq LL 55))
(if (not WL) (setq WL 34))
(if (not TL) (setq TL 17))

(if (not LEFT) (setq LEFT 10))
(if (not RIGHT) (setq RIGHT 10))
(if (not TOP) (setq TOP 10))
(if (not BOTTOM) (setq BOTTOM 10))

(if (not title) (setq title "Casper Mosquito Mats."))

(if (not mm_in_ps) (setq mm_in_ps 1))
(if (not mm_in_ls) (setq mm_in_ls 1))
(if (not mm_in_sm) (setq mm_in_sm 1))
(if (not kb_list) (setq kb_list 1))

(if (not ls_ed) (setq ls_ed 550))
(if (not ws_ed) (setq ws_ed 350))

(if (not ll_ed) (setq ll_ed 55))
(if (not wl_ed) (setq wl_ed 34))
(if (not tl_ed) (setq tl_ed 17))

(if (not left_ed) (setq left_ed 10))
(if (not right_ed) (setq right_ed 10))
(if (not top_ed) (setq top_ed 10))
(if (not bottom_ed) (setq bottom_ed 10))
(setq cpr "Developed at Mudranika by Tushar Suradkr")

(if (= mm_in_ps 1) (set_tile "mmps" "1"))
(if (= mm_in_ps 0) (set_tile "inps" "1"))

(if (= mm_in_ls 1) (set_tile "mmls" "1"))
(if (= mm_in_ls 0) (set_tile "inls" "1"))

(if (= mm_in_sm 1) (set_tile "mmsm" "1"))
(if (= mm_in_sm 0) (set_tile "insm" "1"))


(set_tile "LS" (if (= mm_in_ps 1)
                   (rtos LS 2 2)
                   (rtos ls_inch 2 2)
               )
)
(set_tile "WS" (if (= mm_in_ps 1)
                   (rtos ws 2 2)
                   (rtos ws_inch 2 2)
               )  
)
(set_tile "LL" (rtos LL 2 2))
(set_tile "WL"  (rtos WL 2 2))
(set_tile "TL"  (rtos TL 2 2))

(setq best_dialog (substr cpr 27 1))

(set_tile "LEFT" (rtos LEFT 2 2))
(set_tile "RIGHT"  (rtos RIGHT 2 2))
(set_tile "TOP" (rtos TOP 2 2))
(set_tile "BOTTOM"  (rtos BOTTOM 2 2))

(set_tile "title" title)
(set_tile "copyrite" cpr)
(action_tile "LS"
"(setq ls_ed (distof $value 4) ls_inch (distof $value 4))")

(action_tile "WS"
"(setq ws_ed (distof $value 4) ws_inch (distof $value 4))")

(action_tile "LL"
"(setq ll_ed (distof $value 4))")

(action_tile "WL"
"(setq wl_ed (distof $value 4))")

(action_tile "TL"
"(setq tl_ed (distof $value 4))")

(action_tile "LEFT"
"(setq left_ed (distof $value 4))")

(action_tile "RIGHT"
"(setq right_ed (distof $value 4))")

(action_tile "TOP"
"(setq top_ed (distof $value 4))")

(action_tile "BOTTOM"
"(setq bottom_ed (distof $value 4))")

(action_tile "KBS"  "(kb_switch)")
(action_tile "POPS" "(list_switch)")

(action_tile "mmps" "(setq mm_in_ps 1)")
(action_tile "inps" "(setq mm_in_ps 0)")

(action_tile "mmls" "(setq mm_in_ls 1)")
(action_tile "inls" "(setq mm_in_ls 0)")

(action_tile "mmsm" "(setq mm_in_sm 1)")
(action_tile "insm" "(setq mm_in_sm 0)")

(action_tile "title" "(setq title $value)")

(action_tile "ad_list" "(ad_list)")

(action_tile "accept" "(done_dialog 4)")
(action_tile "cancel" "(done_dialog 0)")

(setq what_c1 (start_dialog))
(unload_dialog c1_id)

(if (= what_c1 4) (progn

																				(if (equal best_dialog "T") (setq dcl$ nil) (progn (alert "Copyright Message tampered with or removed")(exit)))
; *****  start program below this line  *****_____________________________
; *****  start program below this line  *****_____________________________
; *****  start program below this line  *****_____________________________

(set)
(pulldown) ;; process pull down for sheet size

(calc_ps)  ;; calculate paper size
(calc_ls)  ;; calculate sheet size
(calc_sm)  ;; calculate sheet margins
(outline)  ;; draw outline
(margin)   ;; draw margins
(draw_carton)
(reset)
;  **** end program above this line ****_____________________________
;  **** end program above this line ****_____________________________
;  **** end program above this line ****_____________________________

); progn

); if what_now
(princ)
); defun c:carton

;*************;*************;*************;*************;*************;

(defun set ()

(setq CE (getvar "cmdecho"))
(setq BM (getvar "blipmode"))
(setq OSMODE (getvar "osmode"))
(setq LUNITS (getvar "lunits"))
(setq LUPREC (getvar "luprec"))
(setq PBOX (getvar "pickbox"))

(setvar "cmdecho" 0)
(setvar "blipmode" 0)
(setvar "osmode" 0)
(setvar "lunits" 2)
(setvar "luprec" 4)
(setvar "pickbox" 0)

) ;; defun set

;*************;*************;*************;*************;*************;

(defun reset()

(setvar "cmdecho" CE)
(setvar "blipmode" BM)
(setvar "osmode" OSMODE)
(setvar "lunits" LUNITS)
(setvar "luprec" LUPREC)
(setvar "pickbox" PBOX)

); defun reset

;*************;*************;*************;*************;*************;

(defun pulldown()
(if (= kb_list 0)
(progn

(setq in_file (open (findfile "c1list.txt") "r"))
(repeat (+ al_index 1)
(setq in_value (read-line in_file))
)
(close in_file)

(if (= 27)
    (setq in_wid (substr in_value 18 3))
    (setq in_wid (substr in_value 16 3))
)
(setq ws_pull (distof in_wid))

(if (= (strlen in_value) 27)
    (setq in_len (substr in_value 24 3))
    (setq in_len (substr in_value 22 3))
)
(setq ls_pull (distof in_len))

) ;; progn
) ;; if
) ;; defun pulldown

;*************;*************;*************;*************;*************;

(defun ad_list()

(if (= mm_in_ps 1)
(progn
     (setq read_out1 (rtos ls_ed 2 0))
     (setq read_out2 (rtos ws_ed 2 0))

     (setq read_out3 (rtos (/ ls_ed 25.4) 2 2))
     (setq read_out4 (rtos (/ ws_ed 25.4) 2 2))

)
)

(if (= mm_in_ps 0)
(progn
     (setq read_out1 (rtos (* ls_ed 25.4) 2 0))
     (setq read_out2 (rtos (* ws_ed 25.4) 2 0))

     (setq read_out3 (rtos ls_ed 2 2))
     (setq read_out4 (rtos ws_ed 2 2))

)
)

;; 11.50 x 18.00   [292 x 457]

(setq read_out (strcat read_out4 " x " read_out3 "   ["  ;; small x big Inch
                       read_out2 " x " read_out1 "]"     ;; small x big mm
               )
)

(setq l_file (open "c1list.txt" "a"))
(write-line read_out l_file)
(close l_file)

(setq al_index 0 al_list nil al_list '())
(setq file (open "c1list.txt" "r"))
(setq line (read-line file))
(while line
     (setq al_list (append al_list (list line)))
     (setq line (read-line file))
) ;; while

(close file)

(start_list "al_list")
(mapcar 'add_list al_list)
(end_list)

(alert (strcat "Paper Size of" "\n\n"
               read_out4 " x " read_out3 "  Inches" "\n"
             "["  read_out2 " x " read_out1 "]  Millimeters" "\n\n"
               "Added to list at the End !"
       )
)
) ;; ad_list

;*************;*************;*************;*************;*************;

(defun calc_ps()  ;; paper size

(if (= kb_list 0)

    (setq ls ls_pull ws ws_pull)
)

(if (= kb_list 1)

    (if (= mm_in_ps 1)  ;; ie. mm is ON
        (setq ls (fix ls_ed) ws (fix ws_ed))
        (setq ls (fix (* ls_ed 25.4)) ws (fix (* ws_ed 25.4)))
    )

)

) ;; defun calc_ps

;*************;*************;*************;*************;*************;

(defun calc_ls() ;; carton size

(if (= mm_in_ls 1)
    (setq ll ll_ed wl wl_ed tl tl_ed)
    (setq ll (* ll_Ed 25.4) wl (* wl_ed 25.4) tl (* tl_ed 25.4))
)

) ;; defun calc_ls

;*************;*************;*************;*************;*************;

(defun calc_sm()  ;; sheet margins

(if (= mm_in_sm 1)

    (setq left left_ed right right_ed top top_ed bottom bottom_ed)

    (setq left (* left_ed 25.4) right  (* right_ed  25.4)
          top  (* top_ed  25.4) bottom (* bottom_ed 25.4)
    )
)

) ;; defun calc_sm

;*************;*************;*************;*************;*************;

; Draw Sheet Outline

(defun outline ()

(if (not LS) (setq LS 550))
(if (not WS) (setq WS 350))
(if (not LL) (setq LL 55))
(if (not WL) (setq WL 34))

(if (not LEFT) (setq LEFT 10))
(if (not RIGHT) (setq RIGHT 10))
(if (not TOP) (setq TOP 10))
(if (not BOTTOM) (setq BOTTOM 10))

(if (not title) (setq title "Casper Mosquito Mat"))

(if (not mm_in_ps) (setq mm_in_ps 1))
(if (not mm_in_ls) (setq mm_in_ls 1))
(if (not mm_in_sm) (setq mm_in_sm 1))
(if (not kb_list) (setq kb_list 1))

(if (not ls_ed) (setq ls_Ed 550))
(if (not ws_ed) (setq ws_ed 350))

(if (not ll_ed) (setq ll_ed 55))
(if (not wl_ed) (setq wl_ed 34))
(if (not tl_ed) (setq tl_ed 17))

(if (not left_ed) (setq left_ed 10))
(if (not right_ed) (setq right_ed 10))
(if (not top_ed) (setq top_ed 10))
(if (not bottom_ed) (setq bottom_ed 10))

(setq newx (* ls 1.2))
(setq newy (* ws 1.2))

(command "limits" "" (list newx newy))
(command "zoom" "all")
(command "zoom" "all")

(setq stx (/ newx 10))
(setq sty (/ newy 10))
(setq po1 (list stx sty))

(setq x1 (car po1))
(setq y1 (cadr po1))

(setq x2 (+ x1 LS))
(setq y2 y1)
(setq po2 (list x2 y2))

(setq x3 x2)
(setq y3 (+ y2 WS))
(setq po3 (list x3 y3))

(setq x4 x1)
(setq y4 y3)
(setq po4 (list x4 y4))

(setq COL (getvar "cecolor"))
(setvar "cecolor" "3")
(command ".pline" po1 po2 po3 po4 "close")
(setvar "cecolor" COL)

);; End Sheet Outline

;*************;*************;*************;*************;*************;

;; Draw Sheet Actual Size with Margins

(defun margin ()
(setq xa1 (+ x1 left))
(setq ya1 (+ y1 bottom))
(setq pa1 (list xa1 ya1))

(setq xa2 (- x2 right))
(setq ya2 (+ y1 bottom))
(setq pa2 (list xa2 ya2))

(setq xa3 (- x3 right))
(setq ya3 (- y3 top))
(setq pa3 (list xa3 ya3))

(setq xa4 (+ x4 left))
(setq ya4 (- y4 top))
(setq pa4 (list xa4 ya4))

(setq COL (getvar "cecolor"))
(setvar "cecolor" "6")
(command ".pline" pa1 pa2 pa3 pa4 "close")
(setvar "cecolor" COL)

(setq las (distance pa1 pa2))
(setq was (distance pa1 pa4))

);; End Sheet Actual Size with Margins

;*************;*************;*************;*************;*************;

(defun draw_carton()

(cond
((<= tl 30) (setq f1 10))
((and (> tl 30) (<= tl 50)) (setq f1 15))
((> tl 50) (setq f1 20))
) ;;cond

(setq n (* f1 0.8))
(setq r (* f1 0.6))

(setq p1 (polar pa1 (dr 90) (+ f1 tl 1)))
(setq p2 (polar p1 (dr 0 ) wl))
(setq p3 (polar p1 (dr 90) ll))
(setq p4 (polar p3 (dr 0) wl))
(setq x5 (car p3) y5 (+ (cadr p3) tl 1) p5 (list x5 y5))
(setq p6 (polar p5 (dr 0) wl))
(setq p7 (polar p5 (dr 90) (* f1 0.4)))
(setq p8 (polar p7 (dr 0) wl))
(setq x9 (+ (car p7) (* f1 0.6)) y9 (+ (cadr p7) (* f1 0.6)))
(setq p9 (list x9 y9))
(setq p10 (polar p9 (dr 0) (- wl (* f1 1.2))))
(setq p11 (polar p5 (dr 0) n))
(setq p12 (polar p11 (dr 270) 2))
(setq p13 (polar p6 (dr 180) n))
(setq p14 (polar p13 (dr 270) 2))
(setq p15 (polar p11 (dr 270) 1))
(setq p16 (polar p13 (dr 270) 1))

(setq p17 (polar p4 (dr 0) tl))
(setq p18 (polar p17 (dr 0) wl))
(setq p19 (polar p18 (dr 0) tl))
(setq p20 (polar p2  (dr 0) tl))
(setq p21 (polar p20 (dr 0) wl))
(setq p22 (polar p21 (dr 0) tl))
(setq p23 (polar p4 (dr 90) (/ (+ tl f1) 2)))
(setq p24 (polar p23 (dr 0) (- tl n)))
(setq p26 (polar p17 (dr 90) n))
(setq p25 (polar p26 (dr 180) 2))
(setq p27 (polar p18 (dr 90) n))
(setq p28 (polar p27 (dr 0) 2))
(setq p30 (polar p19 (dr 90) (/ (+ tl f1) 2)))
(setq p29 (polar p30 (dr 180) (- tl n)))
(setq p31 (polar p2 (dr 270) n))
(setq p32 (polar p31 (dr 0) 2))
(setq p34 (polar p20 (dr 270) (/ (+ tl f1) 2)))
(setq p33 (polar p34 (dr 180) (- tl n)))
(setq p35 (polar p21 (dr 270) (/ (+ tl f1) 2)))
(setq p36 (polar p35 (dr 0) (- tl n)))
(setq p38 (polar p22 (dr 270) n))
(setq p37 (polar p38 (dr 180) 2))
(setq p39 (polar p22 (dr 30) (/ f1 0.8660254)))
(setq p40 (polar p19 (dr -30) (/ f1 0.8660254)))

(setq tms1 (/ left 2))

(setq xw1 (- (car p1) tms1))
(setq yw1 (+ (cadr p9) tms1))
(setq pw1 (list xw1 yw1))

(setq xw2 (+ (car p4) tms1))
(setq yw2 (- (cadr p4) tms1))
(setq pw2 (list xw2 yw2))

(setq xw3 (- (car p1) tms1))
(setq yw3 (+ (cadr p1) tms1))
(setq pw3 (list xw3 yw3))

(setq xw4 (+ (car p2) tms1))
(setq yw4 (- (cadr p2) (+ f1 tl 1)))
(setq pw4 (list xw4 yw4))

(setq xw5 (- (car p1) tms1))
(setq yw5 (- (cadr pa1) tms1))
(setq pw5 (list xw5 yw5))

(setq xw6 (+ (car pw5) (* tms1 2) f1 (* (+ wl tl) 2)))
(setq yw6 (+ (cadr pw5) (* tms1 2) ll (* (+ tl f1) 2)))
(setq pw6 (list xw6 yw6))

(setq pm1 (polar p1 (dr 90) (/ ll 2.0)))
(setq pm2 (polar p2 (dr 90) (/ ll 2.0)))

(setq n_col (fix (/ las (+ 1 f1 (* (+ wl tl) 2)))))
(setq n_row (fix (/ was (+ 1 ll (* (+ tl f1) 2)))))

(setq d_col (+ 1 f1 (* (+ wl tl) 2)))
(setq d_row (+ 2 ll (* (+ tl f1) 1)))

(setq ce_col (getvar "cecolor"))
(setvar "cecolor" "5")

(command "line" p1 p2 p4 p3 p1 "")
(command "line" p3 p5 "" "line" p4 p6 "")
(command "line" p5 p7 "" "line" p6 p8 "" "line" p9 p10 "")
(command "line" p5 p11 "" "line" p6 p13 "")
(command "line" p11 p12 "" "line" p13 p14 "" "line" p15 p16 "")
(command "line" p2 p22 p19 p4 "" "line" p17 p20 "" "line" p18 p21 "")
(command "line" p23 p24 p25 p26 p17 "")
(command "line" p18 p27 p28 p29 p30 p19 "")
(command "line" p34 p33 p32 "")
(command "line" p35 p36 p37 p38 p22 "")
(command "line" p22 p39 p40 p19 "")

(command "arc" p9 "e" p7 "r" (* f1 0.6))
(command "arc" p8 "E" p10 "r" (* f1 0.6))

(setvar "cecolor" ce_col)

(command "mirror" "w" pw1 pw2 "" pm1 pm2 "")
(command "move" "w" pw3 pw4 "" p1 p20 )

(setq ce_col (getvar "cecolor"))
(setvar "cecolor" "5")
(command "line" p1 p2 "" "redraw")
(command "line" p32 p31 p2 "")
(setvar "cecolor" ce_col)

(command "array" "w" pw5 pw6 "" "r" n_row n_col d_row d_col)


) ;; defun draw_carton

;*************;*************;*************;*************;*************;

(defun dr(dd) (* dd 0.017453278))

;*************;*************;*************;*************;*************;